<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Balkendiagramm</title>
    <style>
        * {
            margin: 0;
        }

    </style>
    <script type="module">
        import { LitElement, css, svg, html } from 'https://unpkg.com/lit-element/lit-element.js?module';
        
        class BarChart extends LitElement
        {
            static get properties()
            {
                return {
                    data : { type: Array },
                }
            }
            static get styles()
            {
                return css``;
            }
            constructor()
            {
                super();
                this.data = [];
            }

            render()
            {                
                var count = this.data.length;
                
                if(count === 0)
                    return;

                var values = this.data.map((d) => d.value);
                var maxVal = values.reduce(function(a, b) {
                                return Math.max(a, b);
                            });
                var maxHeight = 200;
                var maxColHeight = maxHeight/2;
                var maxWidth = window.innerWidth; 
                var distInbetween = 10;               
                var colWidth = (maxWidth-(distInbetween*count)) / count;
                return html`                    
                    <svg style="border: thin solid black; margin: 5px;" width="${maxWidth}" height="${maxHeight}">
                        ${this.data.map((d, index) => {
                            var xCoord = (colWidth + distInbetween) * index;
                        
                            var height = (d.value / maxVal) * 200;
                            var yCoord = maxColHeight - height;
                            //var yCoord = maxColHeight;
                            console.log(`x: ${xCoord}, y: ${yCoord}, d.value: ${d.value}, maxVAl: ${maxVal}, heigt: ${height}`);
                            return svg`
                                <rect x="${xCoord}" y="${yCoord}" width="${colWidth}" height="${height}" style="fill:black">                                    
                                </rect>
                                <text x="${xCoord}" y="${maxHeight*3/4}">${d.label}</text>
                            `;
                        })}
                        <animate attributeName="height" from="0" to="${maxHeight}" dur="1s" fill="freeze"/>
                    </svg> 
                    `;
            }

            setData(data)
            {
                this.data = data;
                super.update();
            }
            addData(data)
            {
                this.data.push(data);
                super.update();
            }
        }
        customElements.define('bar-chart', BarChart)
    </script>
</head>
<body>
    <div>        
    </div>
    <bar-chart></bar-chart>    
    <script>
        const container = document.querySelector("div");
        const barChart = document.querySelector("bar-chart");
        const buttonDemo = document.createElement('button');
        buttonDemo.innerText="Add Demo";
        buttonDemo.onclick = () => 
        {
            for(var i = 0; i < 1; i++)
            {
                var value = Math.random() * 1000;
                var label = "label";
                barChart.addData(
                    {
                        value: value,
                        label: label
                    }
                );          
            }
        }
        container.appendChild(buttonDemo);
    </script>
</body>
</html>